from easygui import *
import sys, math, os, re

while 1:
    msg = ("""
* Welcome to the SatScan-Google Earth Cluster Viewer! *

This process was designed to take the text output file produced by a cluster analysis done in SatScan version 8.x or higher and generate circles in Google Earth based on the output file.  Output from earlier versions of SatScan is not guaranteed to work.""")
    title = "SGECV v.1.0.1"
    if msgbox(msg, title)== 0:     # show a Continue/Cancel dialog
        sys.exit(0)
    else:
        satscan_output = fileopenbox(msg="Please select your SatScan Output File:", title=None, default='*', filetypes='*.txt')
    if satscan_output == 0:
        sys.exit(0)
    else:
        input = open(satscan_output)
        cluster = input.read()
        input.close

        cluster=cluster.replace('< ','')
		
        msg =("What color would you like your clusters to appear?")
        title = "Cluster Color"
        cluster_color = indexbox(msg, title, ["red","orange","yellow","green","blue","white"])
        if cluster_color ==0:
            Color = 'ff0000ff'
        elif cluster_color ==1:
            Color = 'ff00aaff'
        elif cluster_color ==2:
            Color = 'ff00ffff'
        elif cluster_color ==3:
            Color = 'ff00ff00'
        elif cluster_color ==4:
            Color = 'ffffaa00'
        elif cluster_color ==5:
            Color = 'fffcfcfc'

        msg =("What size would you like your icons to appear?")
        title = "Icon Size"
        icon_size = indexbox(msg, title, ["small","large","no icons"])
        if icon_size ==0:
            size = '0.7'
        elif icon_size ==1:
            size = '1.0'
        elif icon_size ==2:
            size = '0.0'
        

                
        output_file = filesavebox(msg='What would you like your file to be called?', title=None, default='*', filetypes='*.kml')
        if output_file == 0:
            sys.exit(0)
        else:
            temp = sys.stdout
            sys.stdout= open(output_file, 'w')
            sys.stdout.write('')
            sys.stdout= open(output_file, 'a')

            sys.stdout.write("""<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document>
	<name>Your Clusters</name>
       <open>1</open>
       <StyleMap id="msn_placemark_circle"> 
       <Pair>
               <key>normal</key>
               <styleUrl>#sn_placemark_circle</styleUrl>
           </Pair>
           <Pair>
               <key>highlight</key>
               <styleUrl>#sh_placemark_circle_highlight</styleUrl>
           </Pair>
       </StyleMap>
       <Style id="sn_placemark_circle">
           <IconStyle>"""
'               <scale>'+ size +'</scale>\n'
'               <color>'+ Color +'</color>\n'
'               <Icon>\n'
'                   <href>http://maps.google.com/mapfiles/kml/paddle/wht-stars.png</href>\n'
'               </Icon>\n'
'           </IconStyle>\n'
'           <LabelStyle>\n'
'               <scale>'+ size +'</scale>\n'       # LABEL FONT SIZE
'           </LabelStyle>\n'
'           <ListStyle>\n'
'               <ItemIcon>\n'
'                   <href>http://maps.google.com/mapfiles/kml/paddle/wht-stars-lv.png</href>\n'
'               </ItemIcon>\n'
'           </ListStyle>\n'
'           <LineStyle>\n'
'                <color>'+ Color +'</color>\n'
'           </LineStyle>\n'
'           <PolyStyle>\n'
'	        <color>00ffffff</color>\n'
'	    </PolyStyle>\n'
'       </Style>\n'   
'       <Style id="sh_placemark_circle_highlight">\n'
'           <IconStyle>\n'
'               <scale>0.6</scale>\n'       # ROLL-OVER ICON SIZE
'               <color>'+Color+'</color>\n'  # ROLL-OVER ICON COLOR
'               <Icon>\n'
'                   <href>http://maps.google.com/mapfiles/kml/shapes/placemark_circle.png</href>\n'
'               </Icon>\n'
'           </IconStyle>\n'
'           <LabelStyle>\n'
'               <scale>.85</scale>\n'       # ROLL-OVER LABEL FONT SIZE
'           </LabelStyle>\n'
'           <ListStyle>\n'
'           </ListStyle>\n'
'           <LineStyle>\n'
'               <color>'+Color+'</color>\n'   # ROLL-OVER LINE COLOR
'           </LineStyle>\n'
'           <PolyStyle>\n'
'	        <color>00ffffff</color>\n'
'	    </PolyStyle>\n'
'       </Style>\n'
'       <StyleMap id="msn_placemark_circle0">\n'
'           <Pair>\n'
'               <key>normal</key>\n'
'               <styleUrl>#sn_placemark_circle</styleUrl>\n'
'           </Pair>\n'
'           <Pair>\n'
'               <key>highlight</key>\n'
'               <styleUrl>#sh_placemark_circle_highlight0</styleUrl>\n'
'           </Pair>\n'
'       </StyleMap>')

               
            latset = re.findall ('[0-9]{2,3}.[0-9]{6}.[NS]',cluster)
            longset = re.findall('[0-9]{2,3}.[0-9]{6}.[EW]',cluster)
            radset = re.findall('[0-9]{1,10}.{,3} km',cluster)
            popset = re.findall('Population............: [0-9]{1,8}',cluster)
            obsset = re.findall('Number of cases.......: [0-9]{1,8}',cluster)
            expset = re.findall('Expected cases........: [0-9]{1,8}.[0-9]{,2}',cluster)
            sirset = re.findall('Observed / expected...: [0-9]{1,8}.[0-9]{,2}',cluster)
            rrset = re.findall('Relative risk.........: [0-9]{1,8}.[0-9]{,2}',cluster)
            llset = re.findall('Log likelihood ratio..: [0-9]{1,8}.[0-9]{6}',cluster)
            pvalue = re.findall('P-value...............: [0-9].[0-9]{1,4}', cluster)

            q = -1
            while q < len(latset)-1:
                q = q + 1
                number = str(q + 1)
                lats = [latset[q]]
                longs = [longset[q]]
                rads = [radset[q]]
                pops = [popset[q]]
                obss = [obsset[q]]
                exps = [expset[q]]
                sirs = [sirset[q]]
                rrs = [rrset[q]]
                lls = [llset[q]]
                pvalues = [pvalue[q]]
                for lat in lats:
                    lat = lat[:-2]
                for long in longs:
                    long = '-'+long[:-2]
                for rad in rads:
                    rad = rad[:-2]
                    if float(rad) == 0:
                        rad = .20
                for pop in pops:
                     pop = pop[24:]
                for obs in obss:
                    obs = obs[24:]
                for exp in exps:
                     exp = exp[24:]
                for sir in sirs:
                     sir = sir[24:]
                for rr in rrs:
                     rr = rr[24:]
                for ll in lls:
                     ll = ll[24:]
                for pval in pvalues:
                    pval = pval[-5:]

                if float(pval) <= 0.05:         # Output will only display clusters with
                    print('     <Folder>')      # p-values less than or equal to .05
                    sys.stdout.write('            <name>Cluster ')
                    sys.stdout.write (number)
                    print ('</name>')
                    sys.stdout.write('            <description>\n')
                    print "Cluster Area....................: "+"%.2f" % float((math.pi*(float(rad))*(float(rad)))/2.589988)+' sq. miles'
                    print "Cluster Population............: "+pop
                    print "Cases Observed.............: "+obs
                    print "Cases Expected..............: "+exp
                    print "SIR...................................: "+sir
                    print "Relative Risk....................: "+"%.2f" % (float(rr))
                    print "Log Likelihood Ratio.........: "+"%.2f" % (float(ll))
                    print "P-value............................: "+pval
                    print('            </description>')
                    print('         <Placemark>')
                    sys.stdout.write('               <name>Cluster ')
                    sys.stdout.write (number)
                    print('</name>')
                    sys.stdout.write('            <description>\n')
                    print "Cluster Area....................: "+"%.2f" % float((math.pi*(float(rad))*(float(rad)))/2.589988)+' sq. miles'
                    print "Cluster Population............: "+pop
                    print "Cases Observed.............: "+obs
                    print "Cases Expected..............: "+exp
                    print "SIR...................................: "+sir
                    print "Relative Risk....................: "+"%.2f" % (float(rr))
                    print "Log Likelihood Ratio.........: "+"%.2f" % (float(ll))
                    print "P-value............................: "+pval
                    print('            </description>')
                    print('               <LookAt>')
                    sys.stdout.write ('                     <longitude>')
                    sys.stdout.write (long)
                    print('</longitude>')
                    sys.stdout.write ('                     <latitude>')
                    sys.stdout.write (lat)
                    print('</latitude>\n'
                    '                   <altitude>1500</altitude>\n'
                    '                   <altitudeMode>relativeToGround</altitudeMode>')
                    print('               </LookAt>\n'
                    '               <styleUrl>#msn_placemark_circle</styleUrl>\n'
                    '               <Point>')
                    sys.stdout.write('                     <coordinates>')
                    sys.stdout.write(long)
                    sys.stdout.write(',')
                    sys.stdout.write(lat)
                    print(',0</coordinates>\n'
                    '               </Point>\n'
                    '         </Placemark>')
                    print('         <Placemark>\n'
                    '               <name>cluster</name>\n'
                    '               <styleUrl>#msn_placemark_circle</styleUrl>\n'
                    '               <Polygon>\n'
                    '                   <extrude>2</extrude>\n'
                    '                   <altitudeMode>relativeToGround</altitudeMode>\n'
                    '                   <outerBoundaryIs>\n'
                    '                       <LinearRing>')
                    sys.stdout.write('                          <coordinates>')

        
        # define 60 points surrounding central point
                    x, y, r = float(long), float(lat), float(rad)
                    longitude = x/180.0*math.pi
                    latitude = y/180.0*math.pi
                    globe = 10018.0 #distance from equator to pole in km
                    i = 0
                    while i <= 360:
                        z = i/180.0*math.pi
                        x2 = x+r*90.0/globe*math.cos(z)/math.cos(latitude)
                        y2 = y+r*90.0/globe*math.sin(z)
                        i = i + 6
                        a=0
                        sys.stdout.write(str(x2))
                        sys.stdout.write(",")
                        sys.stdout.write(str(y2))
                        sys.stdout.write(" ")
                    print('</coordinates>\n'
                        '                       </LinearRing>\n'
                        '                   </outerBoundaryIs>\n'
                        '               </Polygon>\n'
                        '         </Placemark>\n'
                        '     </Folder>')
                else: []

            endkml = ('</Document>\n'
            '</kml>')
            print endkml
            sys.stdout = temp
    msg = 'Would you like Google Earth to open now and display your clusters?'
    title = ''
    ge = ynbox(msg, title)
    if ge == 0: pass
    else:
        os.startfile(output_file)
    msg= "Would you like to choose another file?"
    title= "quit?"
    out = ynbox(msg, title)
    if out ==0:
        sys.exit(0)
    else: pass
